package com.engine.jucailinkq.attendance.attendanceanalysis.cmd.getclockInpoint;

import com.engine.jucailinkq.attendance.attendanceanalysis.cmd.getclockInpoint.biz.AbstractAdjustClockPointAction;
import com.engine.jucailinkq.attendance.attendanceanalysis.dto.clockpoint.ClockPointDTO;
import com.engine.jucailinkq.attendance.attendanceanalysis.dto.clockpoint.ClockPointInfo;
import com.engine.jucailinkq.attendance.enums.CheckBoxEnum;
import com.engine.jucailinkq.attendance.enums.ClassSegmentTypeEnum;
import com.engine.jucailinkq.common.util.DateUtil;
import com.engine.jucailinkq.common.util.Utils;
import com.google.common.collect.Lists;
import weaver.general.Util;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 去除出差中间的卡点，完全根据出差项目配置来
 */
public class AdjustByEvectionCmd extends AbstractAdjustClockPointAction {
    @Override
    public List<ClockPointDTO> execute(ClockPointInfo clockPointInfo) {
        String analysisDate = clockPointInfo.getAnalysisDate();
        //卡点集合
        List<ClockPointDTO> clcokInPointList = clockPointInfo.getClcokInPointList();
        //出差以及请假
        List<Map<String, Object>> askForLeaveAndEvctionScheduleList = clockPointInfo.getAskForLeaveAndEvctionScheduleList();

        List<Map<String, Object>> evectionScheduleList = askForLeaveAndEvctionScheduleList.stream().filter(e-> ClassSegmentTypeEnum.EVECTION.getKey().equals(e.get("bdlx"))).collect(Collectors.toList());

        List<ClockPointDTO> adjustClcokInPointList = Lists.newArrayList();

        for (Map<String, Object> evectionSchedule:evectionScheduleList){
            String kssj = Utils.getkssjTime(evectionSchedule,analysisDate);
            String jssj = Utils.getjssjTime(evectionSchedule,analysisDate);
            String ksdk = evectionSchedule.get("ksdk").toString();
            String jsdk = evectionSchedule.get("jsdk").toString();

            for (int i=0;i<clcokInPointList.size();i++){
                if (DateUtil.getTime(clcokInPointList.get(i).getClassTime()).compareTo(DateUtil.getTime(kssj)) >0 &&
                    DateUtil.getTime(clcokInPointList.get(i).getClassTime()).compareTo(DateUtil.getTime(jssj)) <0){
                    clcokInPointList.remove(i);
                    i--;
                }else if (DateUtil.getTime(clcokInPointList.get(i).getClassTime()).compareTo(DateUtil.getTime(kssj)) == 0 && CheckBoxEnum.UNCHECKED.getKey().equals(ksdk)){
                    clcokInPointList.remove(i);
                    i--;
                }else if (DateUtil.getTime(clcokInPointList.get(i).getClassTime()).compareTo(DateUtil.getTime(jssj)) == 0 && CheckBoxEnum.UNCHECKED.getKey().equals(jsdk)){
                    clcokInPointList.remove(i);
                    i--;
                }

            }

        }

        return clcokInPointList;
    }
}
